> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://reference.flatfile.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://reference.flatfile.com/_mcp/server.

# Add mapping rules to a program

POST https://api.x.flatfile.com/v1/mapping/{programId}/rules
Content-Type: application/json

Add mapping rules to a program

Reference: https://reference.flatfile.com/api-reference/mapping/create-rules

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `programId` (string, required) — ID of the program

### Body (application/json)

This endpoint expects a list of MappingRuleConfig.

- `list of MappingRuleConfig`

## Response

### 200

- `data` (list of MappingRule, required)

## Errors

### 400 Bad Request Error

- `errors` (list of Error, required)

### 404 Not Found Error

- `errors` (list of Error, required)

## Types

### MappingRuleConfig

- `name` (string, required) — Name of the mapping rule
- `type` (string, required)
- `config` (any, optional)
- `acceptedAt` (datetime, optional) — Time the mapping rule was last updated
- `acceptedBy` (string, optional) — User ID of the contributor of the mapping rule
- `metadata` (any, optional) — Metadata of the mapping rule

### MappingRule

- `createdAt` (datetime, required) — Time the mapping rule was created
- `id` (string, required) — ID of the mapping rule
- `name` (string, required) — Name of the mapping rule
- `type` (string, required)
- `updatedAt` (datetime, required) — Time the mapping rule was last updated
- `acceptedAt` (datetime, optional) — Time the mapping rule was last updated
- `acceptedBy` (string, optional) — User ID of the contributor of the mapping rule
- `confidence` (integer, optional) — Confidence of the mapping rule
- `config` (any, optional)
- `createdBy` (string, optional) — User ID of the user who suggested the mapping rule
- `deletedAt` (datetime, optional) — Time the mapping rule was deleted
- `metadata` (any, optional) — Metadata of the mapping rule

### Error

- `message` (string, required)
- `key` (string, optional)

## Examples

**Request**

```json
[
  {
    "name": "name",
    "type": "type"
  },
  {
    "name": "name",
    "type": "type"
  }
]
```

**Response**

```json
{
  "data": [
    {
      "createdAt": "2024-01-15T09:30:00Z",
      "id": "id",
      "name": "name",
      "type": "type",
      "updatedAt": "2024-01-15T09:30:00Z",
      "acceptedAt": "2024-01-15T09:30:00Z",
      "acceptedBy": "acceptedBy",
      "confidence": 1,
      "config": {
        "key": "value"
      },
      "createdBy": "createdBy",
      "deletedAt": "2024-01-15T09:30:00Z",
      "metadata": {
        "key": "value"
      }
    },
    {
      "createdAt": "2024-01-15T09:30:00Z",
      "id": "id",
      "name": "name",
      "type": "type",
      "updatedAt": "2024-01-15T09:30:00Z",
      "acceptedAt": "2024-01-15T09:30:00Z",
      "acceptedBy": "acceptedBy",
      "confidence": 1,
      "config": {
        "key": "value"
      },
      "createdBy": "createdBy",
      "deletedAt": "2024-01-15T09:30:00Z",
      "metadata": {
        "key": "value"
      }
    }
  ]
}
```

**SDK Code**

```python
import requests

url = "https://api.x.flatfile.com/v1/mapping/programId/rules"

payload = [
    {
        "name": "name",
        "type": "type"
    },
    {
        "name": "name",
        "type": "type"
    }
]
headers = {
    "X-Disable-Hooks": "true",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```typescript
import { FlatfileClient } from "@flatfile/api";

const client = new FlatfileClient({ token: "YOUR_TOKEN" });
await client.mapping.createRules("programId", [{
        name: "name",
        type: "type"
    }, {
        name: "name",
        type: "type"
    }]);

```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.x.flatfile.com/v1/mapping/programId/rules"

	payload := strings.NewReader("[\n  {\n    \"name\": \"name\",\n    \"type\": \"type\"\n  },\n  {\n    \"name\": \"name\",\n    \"type\": \"type\"\n  }\n]")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("X-Disable-Hooks", "true")
	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.x.flatfile.com/v1/mapping/programId/rules")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["X-Disable-Hooks"] = 'true'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "[\n  {\n    \"name\": \"name\",\n    \"type\": \"type\"\n  },\n  {\n    \"name\": \"name\",\n    \"type\": \"type\"\n  }\n]"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.x.flatfile.com/v1/mapping/programId/rules")
  .header("X-Disable-Hooks", "true")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("[\n  {\n    \"name\": \"name\",\n    \"type\": \"type\"\n  },\n  {\n    \"name\": \"name\",\n    \"type\": \"type\"\n  }\n]")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.x.flatfile.com/v1/mapping/programId/rules', [
  'body' => '[
  {
    "name": "name",
    "type": "type"
  },
  {
    "name": "name",
    "type": "type"
  }
]',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
    'X-Disable-Hooks' => 'true',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.x.flatfile.com/v1/mapping/programId/rules");
var request = new RestRequest(Method.POST);
request.AddHeader("X-Disable-Hooks", "true");
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "[\n  {\n    \"name\": \"name\",\n    \"type\": \"type\"\n  },\n  {\n    \"name\": \"name\",\n    \"type\": \"type\"\n  }\n]", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "X-Disable-Hooks": "true",
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  [
    "name": "name",
    "type": "type"
  ],
  [
    "name": "name",
    "type": "type"
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.x.flatfile.com/v1/mapping/programId/rules")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```